using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid; 

namespace MasterDetail
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridDataBoundGrid gridDataBoundGrid1;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Button button1;
		private DataSet ds = new DataSet();

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			Init();
			

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridDataBoundGrid1 = new Syncfusion.Windows.Forms.Grid.GridDataBoundGrid();
			this.button1 = new System.Windows.Forms.Button();
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridDataBoundGrid1
			// 
			this.gridDataBoundGrid1.AllowDragSelectedCols = true;
			this.gridDataBoundGrid1.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.gridDataBoundGrid1.Location = new System.Drawing.Point(8, 48);
			this.gridDataBoundGrid1.Name = "gridDataBoundGrid1";
			this.gridDataBoundGrid1.OptimizeInsertRemoveCells = true;
			this.gridDataBoundGrid1.ShowCurrentCellBorderBehavior = Syncfusion.Windows.Forms.Grid.GridShowCurrentCellBorder.GrayWhenLostFocus;
			this.gridDataBoundGrid1.Size = new System.Drawing.Size(568, 392);
			this.gridDataBoundGrid1.SmartSizeBox = false;
			this.gridDataBoundGrid1.SortBehavior = Syncfusion.Windows.Forms.Grid.GridSortBehavior.DoubleClick;
			this.gridDataBoundGrid1.TabIndex = 0;
			this.gridDataBoundGrid1.Text = "Master-View";
			this.gridDataBoundGrid1.ThemesEnabled = true;
			this.gridDataBoundGrid1.UseListChangedEvent = true;
			// 
			// button1
			// 
			this.button1.Location = new System.Drawing.Point(16, 16);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(136, 24);
			this.button1.TabIndex = 5;
			this.button1.Text = "Reset";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(592, 464);
			this.Controls.Add(this.button1);
			this.Controls.Add(this.gridDataBoundGrid1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "Form1";
			this.Text = "Form1";
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.gridDataBoundGrid1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}


		private void Init()
		{
			DataTable dtParent = GetParentTable();
			DataTable dtChild = GetChildTable();

			ds.Tables.Add(dtParent);
			ds.Tables.Add(dtChild);
			ds.Relations.Add("Parent_Child",ds.Tables[0].Columns["ParentID"],ds.Tables[1].Columns["ParentID"]);      
			
			gridDataBoundGrid1.Text = "Master-View";
			gridDataBoundGrid1.Binder.SetDataBinding(ds, "ParentTable");
			GridHierarchyLevel childrenLevel = gridDataBoundGrid1.Binder.AddRelation("Parent_Child");
			childrenLevel.ShowHeaders = false;
			
			gridDataBoundGrid1.Binder.RootHierarchyLevel.ShowHeaders = true;
		}

		private int parentRows = 10;
		private int ChildRows = 30;
		private int GrandChildRows = 80;

		private DataTable GetParentTable()
		{
			DataTable dt = new DataTable("ParentTable");

			dt.Columns.Add(new DataColumn("parentID")); //lower case p
			dt.Columns.Add(new DataColumn("ParentName"));

			for(int i = 0; i < parentRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("parentName{0}", i);
				dt.Rows.Add(dr);
			}

			return dt;
		}

		private Random r = new Random();

		private DataTable GetChildTable()
		{
			DataTable dt = new DataTable("ChildTable");

			dt.Columns.Add(new DataColumn("childID")); //lower case c
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ParentID")); //upper case P
			
			for(int i = 0; i < ChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("ChildName{0}",i);
				dr[2] = r.Next(parentRows).ToString();//(i % parentRows).ToString();
				dt.Rows.Add(dr);
			}
		
			return dt;
		}

		private DataTable GetGrandChildTable()
		{
			DataTable dt = new DataTable("GrandChildTable");

			dt.Columns.Add(new DataColumn("GrandChildID"));
			dt.Columns.Add(new DataColumn("Name"));
			dt.Columns.Add(new DataColumn("ChildID")); //upper case C
			
			for(int i = 0; i < GrandChildRows; ++i)
			{
				DataRow dr = dt.NewRow();
				dr[0] = i.ToString();
				dr[1] = string.Format("GrandChildName{0}",i);
				dr[2] = r.Next(ChildRows).ToString();//(i % ChildRows).ToString();
				dt.Rows.Add(dr);
			}
			
			return dt;
		}

		

		int ichildVisibleRecordCount = 0;
		private void gridDataBoundGrid1_RowExpanded(object sender, GridRowEventArgs e)
		{
            GridBoundRecordState state = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex); 
			ichildVisibleRecordCount += state.ChildCount ;
		}

		private void gridDataBoundGrid1_RowCollapsed(object sender, GridRowEventArgs e)
		{
			
		}

		private void gridDataBoundGrid1_RowCollapsing(object sender, GridRowEventArgs e)
		{
			GridBoundRecordState state = this.gridDataBoundGrid1.Binder.GetRecordStateAtRowIndex(e.RowIndex); 
			ichildVisibleRecordCount -= state.ChildCount ;

		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
		
		}

		private void button1_Click(object sender, System.EventArgs e)
		{
			
			DataSet dss= new DataSet();
			DataTable dtParent = GetChildTable();
			DataTable dtChild = GetGrandChildTable();

			dss.Tables.Add(dtParent);
			dss.Tables.Add(dtChild);
			dss.Relations.Add("Child_grantChild",dss.Tables[0].Columns["childID"],dss.Tables[1].Columns["ChildID"]);      
			

			gridDataBoundGrid1.BeginUpdate(); 
			gridDataBoundGrid1.DataSource = null;
			gridDataBoundGrid1.Binder.ResetHierarchyLevels();  
			gridDataBoundGrid1 .Binder.SetDataBinding(dss, "ChildTable");
			GridHierarchyLevel childrenLevel = gridDataBoundGrid1.Binder.AddRelation("Child_grantChild");
			childrenLevel.ShowHeaders = false;
			gridDataBoundGrid1.Binder.RootHierarchyLevel.ShowHeaders = true;

			gridDataBoundGrid1.EndUpdate(true); 
			gridDataBoundGrid1.Refresh(); 
		
		}
	}
}
